package de.bfpi.kg;

import java.util.List;

import org.jbpm.api.NewDeployment;
import org.jbpm.api.ProcessInstance;
import org.jbpm.api.task.Task;
import org.jbpm.test.JbpmTestCase;

/*	Vorher Prozess in richtige Form bringen
 * 	1. serviceTasks anpassen im Editor schon: 
 * 		Implementierung: 'Other' (wird bisher aber nicht exportiert)
 * 		Operations-Referenz: z.B. 'javamethode'
 * 		Nachrichten-Referen: z.B. 'nachrichtenobjekt'
 * 		Eingabe-Daten-Element: 
 * 		Ausgabe-Daten-Element: 
 * 	2. BPMNDI entfernen
 * 	3. Prozessattribut 'name' vergeben, dabei attribut 'id' sprechend umbenennen
 * 	4. Java-Seite für serviceTasks implementieren
 * 		Interface anlegen
 * 		Messages anlegen, wenn Daten transferiert werden sollen
 * 		ItemDefinitions für Messages (structureRef) anlegen
 * 	5. potentialOwner bei allen userTasks hinzufügen :(
 * 
 */

public class HandlungsansweisungTest extends JbpmTestCase {
	
	final static String process_revision = "10-1";
		
	protected void setUp() throws Exception {
		
		super.setUp();
		
		/* Prozessmodell einbinden und deployen */
		
		NewDeployment deployment = repositoryService.createDeployment();
		deployment.addResourceFromClasspath("handlungsanweisung-rev"+process_revision+".bpmn.xml");
		String deploymentId = deployment.deploy();
		registerDeployment(deploymentId);
		
		/* Beispielnutzer anlegen */
		
		identityService.createGroup("techniker");
		identityService.createUser("tech1", "Alan", "Turing");
		identityService.createMembership("tech1", "techniker");
		
	}
	
	protected void tearDown() throws Exception {
		identityService.deleteUser("tech1");
		identityService.deleteGroup("techniker");
		super.tearDown();
	}
	
	/* 
	 * Parameter messen -> messwert == wert -> Gerät neustart -> fertig
	 * Pfad 1
	 */
	public void testRestartDevice(){
		/* Prozess starten */ 
		ProcessInstance pi = executionService.startProcessInstanceByKey("handlungsanweisung");
		System.out.println(pi.getState());
		System.out.println(pi.findActiveActivityNames().toString());
		
		/* Abfrage, ob Alan Turing Kandidate für den userTask ist */
		List<Task> tasks = taskService.findGroupTasks("tech1");
		assertEquals(1, tasks.size());
		Task requestTask = taskService.createTaskQuery().candidate("tech1").uniqueResult();
		assertNotNull(requestTask);
		
	}

}
